# From Traits to Threats
## Identification of Personality Traits for Individuals at Risk of Radicalisation on Social Media

Implementation of systems in Master's Thesis


The code is distributed across four folders; one for pre-processing of data, one for collection of data, one for the implementation of the personality prediction systems, and one for the final prediction.

To install all necessary packages, run `pip install -r requirements.txt`.


### Pre-processing
This code was used for preparing the accumulated and manually collected data for the experiments in this Master's Thesis. For access to the datasets used for personality prediction, please refer to the information provided in the Thesis or contact the Thesis author for more information.

### Data collection
The code was used to scrape data from the Twitter API to construct the radicalisation_d and non-radical_d datasets. Data scraped using tweepy v2. You need access to Twitter Academic Research API (applicants only) in order to execute this code.

### Prediction system
Contains the code for the models trained and tested as part of this Thesis. All models were trained using IDUN's High Performance Computer (HPC) and executed using .slurm files. The code is implemented to function outside the HPC by default. If you wish to use the code with IDUN's HPC, simply pass the argument `--idun=1` when executing the code for the specific model.

Each file from prediction system has the naming convention:

"feature" . "model" + "num" . "layer" . py

where:

"feature" => features used in combination with model
"model" => model architecture
"num" => indicator whether stopwords are included (1) or stopwords are removed (2)
"layer" => specific for models using transformer-generated features
 
### Final prediction
Contains the code necessary for running a trained personality prediction model on the datasets. 


For any additional questions on e.g. how to run code or use data, please contact the author





